<chapter xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xi="http://www.w3.org/2001/XInclude" version="5.0" xml:lang="hu">
    <info>
        <title>Helló, Calvin!</title>
        <keywordset>
            <keyword />
        </keywordset>
    </info>

    <section>
        <title>MNIST</title>
        <para>
            Az alap feladat megoldása, +saját kézzel rajzolt képet is ismerjen fel,
            <link xlink:href="https://progpater.blog.hu/2016/11/13/hello_samu_a_tensorflow-bol">https://progpater.blog.hu/2016/11/13/hello_samu_a_tensorflow-bol</link>
            Háttérként ezt vetítsük le:
            <link xlink:href="https://prezi.com/0u8ncvvoabcr/no-programming-programming/">https://prezi.com/0u8ncvvoabcr/no-programming-programming/</link>
        </para>
        <para>
            Megoldás videó:
        </para>
        <para>
            Megoldás forrása:    
        </para>
        <para>
            A programban egy neurális hálót hozunk létre és tanítunk fel arra a céra, hogy felismerje az általunk megadott (szerkesztett vagy írt)számot. A neurális hálókról már volt szó korábban a "Neurális OR, AND és EXOR" R-es példánál. Ezt a tanulást egy teszt adatbázisból végzi, ahol több 10000 különböző módon leírt számjegy van (0-9). A teszt adatbázison kívül van egy train adatbázis is ebben képzi fel magát a háló. A tanításról a futtatás során tájékoztat folyamatosan a parancssor, ebben az esetben nagyjából egy ilyen 97-98%-os pontosságot tudunk elérni, de ez nem csoda hiszen egy nem mély hálóról van szó. Minél mélyebb egy háló, annál jobban tudja feltanítani magát, ezáltal adott probléma megoldására annál kisebb esélye lesz a hibázásnak.
        </para>
        <para>
            Ennél a kivitelezésnél minden esetben újra fel kell tanítani a neurális hálózatot, de ezt a hálót ki is lehetne menteni(ezzel a futáskor a programnak nem kell a tanítással is foglalkozni, hanem egyből magára a problémára csak alkalmazza azt).
        </para>
    </section>

    <section>
        <title>Deep MNIST</title>
        <para>
            Mint az előző, de a mély változattal. Segítő ábra, vesd össze a forráskóddal a
            <link xlink:href="https://arato.inf.unideb.hu/batfai.norbert/NEMESPOR/DE/denbatfai2.pdf">https://arato.inf.unideb.hu/batfai.norbert/NEMESPOR/DE/denbatfai2.pdf</link>
            8. fóliáját!
        </para>
        <para>
            Megoldás videó:
        </para>
        <para>
            Megoldás forrása:    
        </para>
        <para>
            Tanulságok, tapasztalatok, magyarázat...
        </para>
    </section>

    <section>
        <title>CIFAR-10</title>
        <para>
            Az alap feladat megoldása, +saját fotót is ismerjen fel,
            <link xlink:href="https://progpater.blog.hu/2016/12/10/hello_samu_a_cifar-10_tf_tutorial_peldabol">https://progpater.blog.hu/2016/12/10/hello_samu_a_cifar-10_tf_tutorial_peldabol</link>
            8. fóliáját!
        </para>
        <para>
            Megoldás videó:
        </para>
        <para>
            Megoldás forrása:    
        </para>
        <para>
            Tanulságok, tapasztalatok, magyarázat...
        </para>
    </section>

    <section>
        <title>Android telefonra a TF objektum detektálója</title>
        <para>
    Telepítsük fel, próbáljuk ki!
	</para>
        <para>
            Megoldás videó:
        </para>
        <para>
            Megoldás forrása: <link xlink:href="https://youtu.be/rqqi2pjL3aw">https://youtu.be/rqqi2pjL3aw</link>
        </para>
        <para>
            Ez az alkalmazás egy relative egyszerű AI -os alkalmazás androidra.
            Egy feltanított neurális hálót használ, ami képes néhány objektumról megállapítani, hogy mi az.
            Nekünk külön a hálót nem kell tanítani ezt készen adták, úgy ahogyan a TF -t sem kell, ez a Gradle scripteknek köszönhető.
            Ez így önmagában nem lenne túl nagy szám, hiszen hasonlót láthattunk a korábbi MNIST -es példában is,
            de ebben az esetben liveban történik mindez a telefonunk kameráján kersztül.
        </para>
        <para>
            A teszteléshez egy androidos Huawei Mate 10 lite telót használtam, amiről a videót is feltöltöttem. Ehhez
            fejlesztői módba kellett állítani a telefont, majd ezután az Android Studio látta az eszközt és a futtatással
            telepítette is az alkalmazást.
        </para>
        <para>
            Neurális háló feltanítása:
            <mediaobject>
                <imageobject>
                    <imagedata fileref="img/mnist.png" scale="25" />
                </imageobject>
            </mediaobject>
        </para>
    </section>

    <section>
        <title>SMNIST for Machines</title>
        <para>
            Készíts saját modellt, vagy használj meglévőt, lásd:
            <link xlink:href="https://arxiv.org/abs/1906.12213">https://arxiv.org/abs/1906.12213</link>
        </para>
        <para>
            Megoldás videó:
        </para>
        <para>
            Megoldás forrása:    
        </para>
        <para>
            Tanulságok, tapasztalatok, magyarázat...
        </para>
    </section>

    <section>
        <title>Minecraft MALMO-s példa</title>
        <para>
            A
            <link xlink:href="https://github.com/Microsoft/malmo">https://github.com/Microsoft/malmo</link>
            felhasználásával egy ágens példa, lásd pl.:
            <link xlink:href="https://youtu.be/bAPSu3Rndi8">https://youtu.be/bAPSu3Rndi8</link>
            ,
            <link xlink:href="https://bhaxor.blog.hu/2018/11/29/eddig_csaltunk_de_innentol_mi">https://bhaxor.blog.hu/2018/11/29/eddig_csaltunk_de_innentol_mi</link>
            ,
            <link xlink:href="https://bhaxor.blog.hu/2018/10/28/minecraft_steve_szemuvege">https://bhaxor.blog.hu/2018/10/28/minecraft_steve_szemuvege</link>
        </para>
        <para>
            Megoldás videó:
        </para>
        <para>
            Megoldás forrása:
            <link xlink:href="https://youtu.be/FtBmIX02SfM">https://youtu.be/FtBmIX02SfM</link>
        </para>
        <para>
            Tavalyi évben foglalkoztunk a témával. Itt egy egyszerű példa, amivel a program folyamatosan displayeli a karaktert 3x3 blokkban körülvevő blokkok típusát és pozícióját.
        </para>
    </section>

    <section>
        <title>EPAM: Reaktív programozás</title>

        <orderedlist>
            <title>Számoljuk ki az első 10 nem negatív egész szám összegét és áltagát.</title>
            <listitem>
                <para>Tegyük mindezt reaktív módon.</para>
            </listitem>
            <listitem>
                <para>A számok előállítását végző komponensre "figyelhessenek" a különböző statisztikákat számító kom-
    ponensek, az egyes számítások pedig párhuzamosan, külön szálon menjenek végbe.</para>
            </listitem>
            <listitem>
                <para>Ügyeljünk arra, hogy a számok előállítása során ne küldjünk több számot az összeget és átlagot szá-
    moló szálaknak, mint amit azok fel tudnak dolgozni, bármilyen lassú is legyen a számítás. Az egyes szá-
    mítások sebessége ne befolyásolja a számok előállításának és más számításoknak a sebességét.</para>
            </listitem>
            <listitem>
                <para>Amennyiben egy számítást végző szál nem tudja fogadni a következő számot, azt mentsük el és kí-
    náljuk fel a szálnak amint kész új számot fogadni. Az így elmentett számok mennyisége legyen limitálva,
    ha túl sok számot kellene elmentenünk, töröljük azt, amelyik a legrégebben érkezett. Ne blokkoljuk a
    számok előállítását, ha van olyan számítást végző szál, amely nem tudja feldolgozni az előállítot szá-
    mot.</para>
            </listitem>
            <listitem>
                <para>A számokat a számítást végző szálak az előállításuknak megfelelő sorrendben dolgozzák fel.</para>
            </listitem>
            <listitem>
                <para>Igyekezzünk minimálisra csökkenteni a blokkolt szálak számát.</para>
            </listitem>
            <listitem>
                <para>A számítást végző szálak fejeződjenek be, ha nincs több feldolgozandó szám.</para>
            </listitem>
            <listitem>
                <para>A megoldásunk legyen nyitott a bővítésre, de zárt a módosításra.</para>
            </listitem>
            <listitem>
                <para>Legyen lehetőség új statisztikák bevezetésére úgy, hogy a meglévő osztályokat nem módosítjuk, il-
    letve szükség esetén tudjunk hasonlóképpen új komponenseket létrehozni a számok előállítására is.</para>
            </listitem>
        </orderedlist>

        <para>
            Megoldás videó:
        </para>
        <para>
            Megoldás forrása:    
        </para>
        <para>
            Tanulságok, tapasztalatok, magyarázat...
        </para>
    </section>

    <section>
        <title>EPAM: Back To The Future</title>
        <para>
            Adott az alábbi kódrészlet:
            <programlisting language="java">
                <![CDATA[public class FutureChainingExercise {

    private static ExecutorService executorService = Executors.newFixedThreadPool(2);

    public static void main(String[] args) {
        CompletableFuture<String> longTask
        = CompletableFuture.supplyAsync(() -> {
        sleep(1000);
        return "Hello";
        }, executorService);

        CompletableFuture<String> shortTask
        = CompletableFuture.supplyAsync(() -> {
        sleep(500);
        return "Hi";
        }, executorService);

        CompletableFuture<String> mediumTask
        = CompletableFuture.supplyAsync(() -> {
        sleep(750);
        return "Hey";
        }, executorService);

        CompletableFuture<String> result
        = longTask.applyToEitherAsync(shortTask, String::toUpperCase, executorService);

        result = result.thenApply(s -> s + " World");

        CompletableFuture<Void> extraLongTask
        = CompletableFuture.supplyAsync(() -> {
        sleep(1500);
        return null;
        }, executorService);

        result = result.thenCombineAsync(mediumTask, (s1, s2) -> s2 + ", " +
        s1, executorService);

        System.out.println(result.getNow("Bye"));
        sleep(1500);
        System.out.println(result.getNow("Bye"));

        result.runAfterBothAsync(extraLongTask, () -
        > System.out.println("After both!"), executorService);
        result.whenCompleteAsync((s, throwable) -> System.out.println("Complete: " +
        s), executorService);

        executorService.shutdown();
        }

        /**
        *
        * @param sleeptime sleep time in milliseconds
        */
        private static void sleep(int sleeptime) {...}

    }]]>
            </programlisting>
            Mi lesz kiíratva a standard kimenetre és miért?
        </para>
        <para>
            Megoldás videó:
        </para>
        <para>
            Megoldás forrása:    
        </para>
        <para>
            Tanulságok, tapasztalatok, magyarázat...
        </para>
    </section>

    <section>
        <title>EPAM: AOP</title>
        <para>
    Készíts két példa projektet, melyben egyes metódusok futási idejét méred majd kiíratod úgy, hogy a metó-
dus futási idejének méréséhez AOP-t használsz. Az első projektben csak az AspectJ könyvtárat, a második
esetében pedig Spring AOP-t használj.
	</para>
        <para>
            Megoldás videó:
        </para>
        <para>
            Megoldás forrása:    
        </para>
        <para>
            Tanulságok, tapasztalatok, magyarázat...
        </para>
    </section>

</chapter>
